%global pypi_name twisted

%global commitId f3f3389b1ee2605fb6d4c6d9dfb3913e84b11cde
%global upstream_version twisted-23.10.0

%global common_description %{expand:
Twisted is a networking engine written in Python, supporting numerous protocols.
It contains a web server, numerous chat clients, chat servers, mail servers
and more.}
%global common_summary %{expand: An asynchronous networking framework written in Python}

%if 0%{?rhel} == 8
%global component_prefix 3x
%endif

Name:           python%{?component_prefix}-%{pypi_name}
Version:        %(echo %{upstream_version} | %{__sed} -e 's#^twisted-##')
Release:        1%{?dist}
Summary:        %{common_summary}

License:        MIT
URL:            https://github.com/twisted/twisted
Source0:        python-twisted-f3f3389b1ee2605fb6d4c6d9dfb3913e84b11cde.tar.gz
Patch0:         remove_fancy_pypi.patch

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-hatchling >= 1.10.0
BuildRequires:  python%{python3_pkgversion}-incremental >= 22.10.0
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-wheel

%description
%{common_description}

%package -n     python%{python3_pkgversion}-%{pypi_name}

Summary:        %{common_summary}

Requires:       python%{python3_pkgversion}-zope-interface >= 5
Requires:       python%{python3_pkgversion}-constantly >= 15.1
Requires:       python%{python3_pkgversion}-incremental >= 22.10.0
Requires:       python%{python3_pkgversion}-Automat >= 0.8.0
Requires:       python%{python3_pkgversion}-hyperlink >= 17.1.1
Requires:       python%{python3_pkgversion}-attrs >= 21.3.0
Requires:       python%{python3_pkgversion}-typing-extensions >= 4.2.0

%description -n python%{python3_pkgversion}-%{pypi_name}
%{common_description}

%package -n python%{python3_pkgversion}-%{pypi_name}+tls

Summary:        Twisted with TLS extras

Requires:       python%{python3_pkgversion}-%{pypi_name} = %{version}-%{release}
Requires:       python%{python3_pkgversion}-pyOpenSSL >= 21.0.0
Requires:       python%{python3_pkgversion}-service-identity >= 18.1.0
Requires:       python%{python3_pkgversion}-idna >= 2.4

%description -n python%{python3_pkgversion}-%{pypi_name}+tls
Twisted with TLS extras

%prep
%autosetup -p 1 -n python-%{pypi_name}-%{commitId}

%build
%{__python3} -m pip wheel --wheel-dir %{_builddir}/wheeldir --no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --no-clean --progress-bar off --verbose .

%install
%{__python3} -m pip install --root %{buildroot} --no-deps --disable-pip-version-check --progress-bar off --verbose --ignore-installed --no-warn-script-location --no-index --no-cache-dir --find-links %{_builddir}/wheeldir %{pypi_name}==%{version}
sed -i 's/pip/rpm/' %{buildroot}/%{python3_sitelib}/%{pypi_name}-%{version}.dist-info/INSTALLER
rm -fv %{buildroot}/%{python3_sitelib}/%{pypi_name}-%{version}.dist-info/{RECORD,REQUESTED}

%files -n python%{python3_pkgversion}-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/ckeygen
%{_bindir}/cftp
%{_bindir}/conch
%{_bindir}/mailmail
%{_bindir}/pyhtmlizer
%{_bindir}/tkconch
%{_bindir}/trial
%{_bindir}/twist
%{_bindir}/twistd
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}.dist-info

%files -n python%{python3_pkgversion}-%{pypi_name}+tls
%ghost %{python3_sitelib}/%{pypi_name}-%{version}.dist-info

%changelog
* Wed Nov 01 2023 Satoe Imaishi <simaishi@redhat.com> 23.10.0-1
- Update to 23.10.0
- Fix CVE-2023-46137 (disordered HTTP pipeline response in twisted.web)

* Thu Feb 09 2023 James Marshall <jamarsha@redhat.com> 22.10.0-1
- Initial release
